#include "stdafx.h"
#include "TextureClass.h"
#include "FontClass.h"

#include <fstream>
using namespace std;


FontClass::FontClass()
{
}

FontClass::FontClass(const FontClass& other)
{
}

FontClass::~FontClass()
{
}


bool FontClass::Initialize(ID3D11Device* device, ID3D11DeviceContext* deviceContext, const char* fontFilename, const char* textureFilename, 
						   float fontHeight, int spaceSize)
{
	// Ʈ ̸ մϴ.
	m_fontHeight = fontHeight;

	// ȼ ũ  ũ⸦ Ͻʽÿ.
	m_spaceSize = spaceSize;
	
	// Ʈ ͸  ؽƮ ϿεѴ.
	if (!LoadFontData(fontFilename))
	{
		return false;
	}

	// Ʈ ڰ ִ ؽó εմϴ.
	return LoadTexture(device, deviceContext, textureFilename);
}


void FontClass::Shutdown()
{
	// Ʈ ؽó մϴ.
	ReleaseTexture();

	// Ʈ ͸ մϴ.
	ReleaseFontData();
}


bool FontClass::LoadFontData(const char* filename)
{
	// ۲  ۸ մϴ.
	m_Font = new FontType[95];
	if (!m_Font)
	{
		return false;
	}

	//   ۲ ũ  нϴ.
	ifstream fin;
	fin.open(filename);
	if (fin.fail())
	{
		return false;
	}

	// ؽƮ   ASCII  95  нϴ.
	for (int i = 0; i<95; i++)
	{
		char temp = 0;
		fin.get(temp);
		while (temp != ' ')
		{
			fin.get(temp);
		}
		fin.get(temp);
		while (temp != ' ')
		{
			fin.get(temp);
		}

		fin >> m_Font[i].left;
		fin >> m_Font[i].right;
		fin >> m_Font[i].size;
	}

	//  ݽϴ.
	fin.close();

	return true;
}


void FontClass::ReleaseFontData()
{
	// Ʈ  迭 Ѵ.
	if (m_Font)
	{
		delete[] m_Font;
		m_Font = 0;
	}
}


bool FontClass::LoadTexture(ID3D11Device* device, ID3D11DeviceContext* deviceContext, const char* filename)
{
	// ؽó Ʈ Ѵ.
	m_Texture = new TextureClass;
	if (!m_Texture)
	{
		return false;
	}

	// ؽó Ʈ ʱȭѴ.
	return m_Texture->Initialize(device, deviceContext, filename);
}


void FontClass::ReleaseTexture()
{
	// ؽó Ʈ Ѵ.
	if (m_Texture)
	{
		m_Texture->Shutdown();
		delete m_Texture;
		m_Texture = 0;
	}
}


ID3D11ShaderResourceView* FontClass::GetTexture()
{
	return m_Texture->GetTexture();
}


void FontClass::BuildVertexArray(void* vertices, const char* sentence, float drawX, float drawY)
{
	// Է  VertexType   ȯմϴ.
	VertexType* vertexPtr = (VertexType*)vertices;

	//    Ͻʽÿ.
	int numLetters = (int)strlen(sentence);

	//  迭  ε ʱȭմϴ.
	int index = 0;
	int letter = 0;

	//  ڸ   ׸ϴ.
	for (int i = 0; i<numLetters; i++)
	{
		letter = ((int)sentence[i]) - 32;

		// ڰ ̸ 3 ȼ  ̵մϴ.
		if (letter == 0)
		{
			drawX = drawX + (float)m_spaceSize;
		}
		else
		{
			//  ù ° ﰢ.
			vertexPtr[index].position = XMFLOAT3(drawX, drawY, 0.0f);  //  
			vertexPtr[index].texture = XMFLOAT2(m_Font[letter].left, 0.0f);
			index++;

			vertexPtr[index].position = XMFLOAT3((drawX + m_Font[letter].size), (drawY - m_fontHeight), 0.0f);  //  Ʒ
			vertexPtr[index].texture = XMFLOAT2(m_Font[letter].right, 1.0f);
			index++;

			vertexPtr[index].position = XMFLOAT3(drawX, (drawY - m_fontHeight), 0.0f);  //  Ʒ
			vertexPtr[index].texture = XMFLOAT2(m_Font[letter].left, 1.0f);
			index++;

			//   ° ﰢ.
			vertexPtr[index].position = XMFLOAT3(drawX, drawY, 0.0f);  //  
			vertexPtr[index].texture = XMFLOAT2(m_Font[letter].left, 0.0f);
			index++;

			vertexPtr[index].position = XMFLOAT3(drawX + m_Font[letter].size, drawY, 0.0f);  //  
			vertexPtr[index].texture = XMFLOAT2(m_Font[letter].right, 0.0f);
			index++;

			vertexPtr[index].position = XMFLOAT3((drawX + m_Font[letter].size), (drawY - m_fontHeight), 0.0f);  //  Ʒ
			vertexPtr[index].texture = XMFLOAT2(m_Font[letter].right, 1.0f);
			index++;

			//  ũ  ȼ  ׸⸦  x ġ Ʈմϴ.
			drawX = drawX + m_Font[letter].size + 1.0f;
		}
	}
}


int FontClass::GetSentencePixelLength(const char* sentence)
{
	int pixelLength = 0;
	int letter = 0;

	for(size_t i=0; i<strlen(sentence); i++)
	{
		letter = ((int)sentence[i]) - 32;

		// ڰ ̸ 3 ȼ մϴ.
		if(letter == 0)
		{
			pixelLength += m_spaceSize;
		}
		else
		{
			pixelLength += (m_Font[letter].size + 1);
		}
	}

	return pixelLength;
}


int FontClass::GetFontHeight()
{
	return (int)m_fontHeight;
}