#pragma once

class BitmapClass;
class ShaderManagerClass;

class MiniMapClass
{
public:
	MiniMapClass();
	MiniMapClass(const MiniMapClass&);
	~MiniMapClass();

	bool Initialize(ID3D11Device*, ID3D11DeviceContext*, int, int, float, float);
	void Shutdown();
	bool Render(ID3D11DeviceContext*, ShaderManagerClass*, XMMATRIX, XMMATRIX, XMMATRIX);
	
	void PositionUpdate(float, float);

private:
	int m_mapLocationX = 0;
	int m_mapLocationY = 0;
	int m_pointLocationX = 0;
	int m_pointLocationY = 0;
	float m_mapSizeX = 0.0f;
	float m_mapSizeY = 0.0f;
	float m_terrainWidth = 0.0f;
	float m_terrainHeight = 0.0f;
	BitmapClass* m_MiniMapBitmap = nullptr;
	BitmapClass* m_PointBitmap = nullptr;
};